/*
	File:		CommToolboxINIT.r

	Contains:	startup resources for the CommToolbox

	Written by:	Byron Han, Alex Kazim, Jerry Godes

	Copyright:	 1988-1991 by Apple Computer, Inc., all rights reserved.

    This file is used in these builds: BigBang

	Change History (most recent first):

		<13>	  7/3/91	BH		changed version to 7.1d1
		<12>	 3/29/91	kaz		Final version strings!!
		<11>	  2/5/91	kaz		jng: Updating version strings
		<10>	  1/9/91	kaz		<jng> Changing ModemStringType and PrinterStringType to STR# to
									include driver names. Update version strings.
		 <9>	12/10/90	kaz		b3 version strings <BBH>
		 <8>	 11/6/90	kaz		Changing version string to b2.
		 <7>	 11/1/90	fjs		add color icons for the modem port and printer port
		 <6>	  8/5/90	kaz		Version string for a3.
		 <5>	  7/2/90	kaz		Version Alpha!!
		 <4>	 6/24/90	kaz		Updated 'vers' resource to 1.0.1 scheme.
		 <3>	 3/21/90	BBH		change version to 7.0d4
		 <2>	 3/16/90	BBH		consolidated all startup resources here
		 <1>	 3/14/90	BBH		first checked in
	   <46+>	 2/20/90	BBH		removed ctbs -32509

	To Do:
	
		decide what to do about the internal modem port on the portable

	Pre-BBS Modification History
		5/24/89		BBH		Changed baseID from -10240 to -10176
		7/27/89		BBH		Changed ctbz to use baseID
							Removed bdc  resource
							
							New already installed and cannot install icons
		9/1/89		BBH		Changed Communications to Communications Folder
		10/1/89		kaz		Changed Small & Large Memory Icons so they show
								up better on a grey desktop
		11/7/89		BBH		Wheaties/Bill no longer needs the ICN#'s
		11/9/89		BBH		Wheaties gives  to 1990.
*/

#include "SysTypes.r"
#include "Types.r"
#include "CommToolboxPriv.r"

resource 'vers' (CTB_VersionID) {
	0x07, 
	0x10, 
	development, 
	0x01,
	verUS,
	"7.1d1",
	"7.1d1,  Apple Computer, Inc. 1988-1991"
};

/*	comm folder name */
resource CTB_CommFolderNameType (CTB_CommFolderNameID, purgeable) {
	"Communications Folder"
};

data CTB_MarkerType (CTB_CTB6MarkerID)
{
};

data CTB_MarkerType (CTB_CTB7MarkerID)
{
};


resource CTB_ModemStringType (CTB_ModemStringID, purgeable) {
	{
	"Modem Port",
	".AIn",
	".AOut"
	}
};

resource CTB_ModemStringType (CTB_PrinterStringID, purgeable) {
	{
	"Printer Port",
	".BIn",
	".BOut"
	}
};

/*	modem port icon */
resource CTB_ModemIconType (CTB_ModemIconID, purgeable) {
	{	/* array: 2 elements */
		/* [1] */
		$"FFFF FFFF 8000 0001 8000 0001 8000 0031"
		$"8000 0049 81C0 0049 8220 0131 8410 0081"
		$"8810 0641 8808 0901 9008 0901 9008 2601"
		$"9010 1001 9060 C801 8881 2001 8881 2001"
		$"8484 C001 8442 0001 8221 0001 8210 0E01"
		$"8108 1181 8084 2041 8042 2021 8021 C021"
		$"8010 0021 800C 0041 8003 0081 8000 C301"
		$"8000 3C01 8000 0001 8000 0001 FFFF FFFF",
		/* [2] */
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
	}
};

// 4 color modem port icon

resource CTB_Modem4ColorIconType (CTB_ModemIconID, purgeable) {
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
	$"FC0C 0C0C 0C0C 0C0C 0C0C 0C0C 0C0C 0C0F"
	$"F0C0 C0C0 C0C0 C0C0 C0C0 C0C0 C0C0 C0CF"
	$"FC0C 0C0C 0C0C 0C0C 0C0C 0C0C 0CFF 0C0F"
	$"F0C0 C0C0 C0C0 C0C0 C0C0 C0C0 CFC0 F0CF"
	$"FC0C 0C0F FF0C 0C0C 0C0C 0C0C 0F0C FC0F"
	$"F0C0 C0FD DDF0 C0C0 C0C0 C0CF C0FF C0CF"
	$"FC0C 0FDD DDDF 0C0C 0C0C 0C0C FC0C 0C0F"
	$"F0C0 FDDD DDDF C0C0 C0C0 CFF0 CFC0 C0CF"
	$"FC0C FDDD DDDD FC0C 0C0C FC0F 0C0C 0C0F"
	$"F0CF DDDD DDDD F0C0 C0C0 F0CF C0C0 C0CF"
	$"FC0F DDDD DDDD FC0C 0CFC 0FFC 0C0C 0C0F"
	$"F0CF DDDD DDDF C0C0 C0CF C0C0 C0C0 C0CF"
	$"FC0F DDDD DFFC 0C0C FF0C FC0C 0C0C 0C0F"
	$"F0C0 FDDD F0C0 C0CF C0F0 C0C0 C0C0 C0CF"
	$"FC0C FDDD FC0C 0C0F 0CFC 0C0C 0C0C 0C0F"
	$"F0C0 CFDD F0C0 CFC0 FFC0 C0C0 C0C0 C0CF"
	$"FC0C 0FDD DF0C 0CFC 0C0C 0C0C 0C0C 0C0F"
	$"F0C0 C0FD DDF0 C0CF C0C0 C0C0 C0C0 C0CF"
	$"FC0C 0CFD DDDF 0C0C 0C0C FFFC 0C0C 0C0F"
	$"F0C0 C0CF DDDD F0C0 C0CF DDDF F0C0 C0CF"
	$"FC0C 0C0C FDDD DF0C 0CFD DDDD DF0C 0C0F"
	$"F0C0 C0C0 CFDD DDF0 C0FD DDDD DDF0 C0CF"
	$"FC0C 0C0C 0CFD DDDF FFDD DDDD DDFC 0C0F"
	$"F0C0 C0C0 C0CF DDDD DDDD DDDD DDF0 C0CF"
	$"FC0C 0C0C 0C0C FFDD DDDD DDDD DF0C 0C0F"
	$"F0C0 C0C0 C0C0 C0FF DDDD DDDD F0C0 C0CF"
	$"FC0C 0C0C 0C0C 0C0C FFDD DDFF 0C0C 0C0F"
	$"F0C0 C0C0 C0C0 C0C0 C0FF FFC0 C0C0 C0CF"
	$"FC0C 0C0C 0C0C 0C0C 0C0C 0C0C 0C0C 0C0F"
	$"F0C0 C0C0 C0C0 C0C0 C0C0 C0C0 C0C0 C0CF"
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
};

// 8 color modem port icon

resource CTB_Modem8ColorIconType (CTB_ModemIconID, purgeable) {
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
	$"FFF6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6"
	$"F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6FF"
	$"FFF6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6"
	$"F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6FF"
	$"FFF6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6"
	$"F6F6 F6F6 F6F6 F6F6 F6F6 FFFF F6F6 F6FF"
	$"FFF6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6"
	$"F6F6 F6F6 F6F6 F6F6 F6FF F6F6 FFF6 F6FF"
	$"FFF6 F6F6 F6F6 F6FF FFFF F6F6 F6F6 F6F6"
	$"F6F6 F6F6 F6F6 F6F6 F6FF F6F6 FFF6 F6FF"
	$"FFF6 F6F6 F6F6 FFF8 F8F8 FFF6 F6F6 F6F6"
	$"F6F6 F6F6 F6F6 F6FF F6F6 FFFF F6F6 F6FF"
	$"FFF6 F6F6 F6FF F8F8 F8F8 F8FF F6F6 F6F6"
	$"F6F6 F6F6 F6F6 F6F6 FFF6 F6F6 F6F6 F6FF"
	$"FFF6 F6F6 FFF8 F8F8 F8F8 F8FF F6F6 F6F6"
	$"F6F6 F6F6 F6FF FFF6 F6FF F6F6 F6F6 F6FF"
	$"FFF6 F6F6 FFF8 F8F8 F8F8 F8F8 FFF6 F6F6"
	$"F6F6 F6F6 FFF6 F6FF F6F6 F6F6 F6F6 F6FF"
	$"FFF6 F6FF F8F8 F8F8 F8F8 F8F8 FFF6 F6F6"
	$"F6F6 F6F6 FFF6 F6FF F6F6 F6F6 F6F6 F6FF"
	$"FFF6 F6FF F8F8 F8F8 F8F8 F8F8 FFF6 F6F6"
	$"F6F6 FFF6 F6FF FFF6 F6F6 F6F6 F6F6 F6FF"
	$"FFF6 F6FF F8F8 F8F8 F8F8 F8FF F6F6 F6F6"
	$"F6F6 F6FF F6F6 F6F6 F6F6 F6F6 F6F6 F6FF"
	$"FFF6 F6FF F8F8 F8F8 F8FF FFF6 F6F6 F6F6"
	$"FFFF F6F6 FFF6 F6F6 F6F6 F6F6 F6F6 F6FF"
	$"FFF6 F6F6 FFF8 F8F8 FFF6 F6F6 F6F6 F6FF"
	$"F6F6 FFF6 F6F6 F6F6 F6F6 F6F6 F6F6 F6FF"
	$"FFF6 F6F6 FFF8 F8F8 FFF6 F6F6 F6F6 F6FF"
	$"F6F6 FFF6 F6F6 F6F6 F6F6 F6F6 F6F6 F6FF"
	$"FFF6 F6F6 F6FF F8F8 FFF6 F6F6 F6FF F6F6"
	$"FFFF F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6FF"
	$"FFF6 F6F6 F6FF F8F8 F8FF F6F6 F6F6 FFF6"
	$"F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6FF"
	$"FFF6 F6F6 F6F6 FFF8 F8F8 FFF6 F6F6 F6FF"
	$"F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6FF"
	$"FFF6 F6F6 F6F6 FFF8 F8F8 F8FF F6F6 F6F6"
	$"F6F6 F6F6 FFFF FFF6 F6F6 F6F6 F6F6 F6FF"
	$"FFF6 F6F6 F6F6 F6FF F8F8 F8F8 FFF6 F6F6"
	$"F6F6 F6FF F8F8 F8FF FFF6 F6F6 F6F6 F6FF"
	$"FFF6 F6F6 F6F6 F6F6 FFF8 F8F8 F8FF F6F6"
	$"F6F6 FFF8 F8F8 F8F8 F8FF F6F6 F6F6 F6FF"
	$"FFF6 F6F6 F6F6 F6F6 F6FF F8F8 F8F8 FFF6"
	$"F6F6 FFF8 F8F8 F8F8 F8F8 FFF6 F6F6 F6FF"
	$"FFF6 F6F6 F6F6 F6F6 F6F6 FFF8 F8F8 F8FF"
	$"FFFF F8F8 F8F8 F8F8 F8F8 FFF6 F6F6 F6FF"
	$"FFF6 F6F6 F6F6 F6F6 F6F6 F6FF F8F8 F8F8"
	$"F8F8 F8F8 F8F8 F8F8 F8F8 FFF6 F6F6 F6FF"
	$"FFF6 F6F6 F6F6 F6F6 F6F6 F6F6 FFFF F8F8"
	$"F8F8 F8F8 F8F8 F8F8 F8FF F6F6 F6F6 F6FF"
	$"FFF6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 FFFF"
	$"F8F8 F8F8 F8F8 F8F8 FFF6 F6F6 F6F6 F6FF"
	$"FFF6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6"
	$"FFFF F8F8 F8F8 FFFF F6F6 F6F6 F6F6 F6FF"
	$"FFF6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6"
	$"F6F6 FFFF FFFF F6F6 F6F6 F6F6 F6F6 F6FF"
	$"FFF6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6"
	$"F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6FF"
	$"FFF6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6"
	$"F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6FF"
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
};



/*	printer port icon */
resource CTB_ModemIconType (CTB_PrinterIconID, purgeable) {
	{
		/* [1] */
		$"FFFF FFFF 8000 0001 8000 0001 8000 0001"
		$"80FF C001 8080 6001 8080 5001 8080 4801"
		$"8080 4401 8080 7E01 8080 0201 8080 0201"
		$"8080 0201 8080 0201 8080 0201 8080 0201"
		$"8080 0201 8080 0201 8F80 03E1 8880 0221"
		$"8880 0239 88FF FE29 8800 0029 8800 0029"
		$"8800 0039 8800 0021 8800 0021 8FFF FFE1"
		$"8000 0001 8000 0001 8000 0001 FFFF FFFF",
		/* [2] */
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
	}
};

// 4 color printer port icon

resource CTB_Printer4ColorIconType (CTB_PrinterIconID, purgeable) {
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
	$"FC0C 0C0C 0C0C 0C0C 0C0C 0C0C 0C0C 0C0F"
	$"F0C0 C0C0 C0C0 C0C0 C0C0 C0C0 C0C0 C0CF"
	$"FC0C 0C0C 0C0C 0C0C 0C0C 0C0C 0C0C 0C0F"
	$"F0C0 C0C0 FFFF FFFF FFC0 C0C0 C0C0 C0CF"
	$"FC0C 0C0C F000 0000 0FFC 0C0C 0C0C 0C0F"
	$"F0C0 C0C0 F000 0000 0F0F C0C0 C0C0 C0CF"
	$"FC0C 0C0C F000 0000 0F00 FC0C 0C0C 0C0F"
	$"F0C0 C0C0 F000 0000 0F00 0FC0 C0C0 C0CF"
	$"FC0C 0C0C F000 0000 0FFF FFFC 0C0C 0C0F"
	$"F0C0 C0C0 F000 0000 0000 00F0 C0C0 C0CF"
	$"FC0C 0C0C F000 0000 0000 00FC 0C0C 0C0F"
	$"F0C0 C0C0 F000 0000 0000 00F0 C0C0 C0CF"
	$"FC0C 0C0C F000 0000 0000 00FC 0C0C 0C0F"
	$"F0C0 C0C0 F000 0000 0000 00F0 C0C0 C0CF"
	$"FC0C 0C0C F000 0000 0000 00FC 0C0C 0C0F"
	$"F0C0 C0C0 F000 0000 0000 00F0 C0C0 C0CF"
	$"FC0C 0C0C F000 0000 0000 00FC 0C0C 0C0F"
	$"F0C0 FFFF F000 0000 0000 00FF FFF0 C0CF"
	$"FC0C FDDD F000 0000 0000 00FD DDFC 0C0F"
	$"F0C0 FDDD F000 0000 0000 00FD DDFF F0CF"
	$"FC0C FDDD FFFF FFFF FFFF FFFD DDF0 FC0F"
	$"F0C0 FDDD DDDD DDDD DDDD DDDD DDF0 F0CF"
	$"FC0C FDDD DDDD DDDD DDDD DDDD DDF0 FC0F"
	$"F0C0 FDDD DDDD DDDD DDDD DDDD DDFF F0CF"
	$"FC0C FDDD DDDD DDDD DDDD DDDD DDFC 0C0F"
	$"F0C0 FDDD DDDD DDDD DDDD DDDD DDF0 C0CF"
	$"FC0C FFFF FFFF FFFF FFFF FFFF FFFC 0C0F"
	$"F0C0 C0C0 C0C0 C0C0 C0C0 C0C0 C0C0 C0CF"
	$"FC0C 0C0C 0C0C 0C0C 0C0C 0C0C 0C0C 0C0F"
	$"F0C0 C0C0 C0C0 C0C0 C0C0 C0C0 C0C0 C0CF"
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
};

// 8 color printer port icon

resource CTB_Printer8ColorIconType (CTB_PrinterIconID, purgeable) {
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
	$"FFF6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6"
	$"F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6FF"
	$"FFF6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6"
	$"F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6FF"
	$"FFF6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6"
	$"F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6FF"
	$"FFF6 F6F6 F6F6 F6F6 FFFF FFFF FFFF FFFF"
	$"FFFF F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6FF"
	$"FFF6 F6F6 F6F6 F6F6 FF00 0000 0000 0000"
	$"00FF FFF6 F6F6 F6F6 F6F6 F6F6 F6F6 F6FF"
	$"FFF6 F6F6 F6F6 F6F6 FF00 0000 0000 0000"
	$"00FF 00FF F6F6 F6F6 F6F6 F6F6 F6F6 F6FF"
	$"FFF6 F6F6 F6F6 F6F6 FF00 0000 0000 0000"
	$"00FF 0000 FFF6 F6F6 F6F6 F6F6 F6F6 F6FF"
	$"FFF6 F6F6 F6F6 F6F6 FF00 0000 0000 0000"
	$"00FF 0000 00FF F6F6 F6F6 F6F6 F6F6 F6FF"
	$"FFF6 F6F6 F6F6 F6F6 FF00 0000 0000 0000"
	$"00FF FFFF FFFF FFF6 F6F6 F6F6 F6F6 F6FF"
	$"FFF6 F6F6 F6F6 F6F6 FF00 0000 0000 0000"
	$"0000 0000 0000 FFF6 F6F6 F6F6 F6F6 F6FF"
	$"FFF6 F6F6 F6F6 F6F6 FF00 0000 0000 0000"
	$"0000 0000 0000 FFF6 F6F6 F6F6 F6F6 F6FF"
	$"FFF6 F6F6 F6F6 F6F6 FF00 0000 0000 0000"
	$"0000 0000 0000 FFF6 F6F6 F6F6 F6F6 F6FF"
	$"FFF6 F6F6 F6F6 F6F6 FF00 0000 0000 0000"
	$"0000 0000 0000 FFF6 F6F6 F6F6 F6F6 F6FF"
	$"FFF6 F6F6 F6F6 F6F6 FF00 0000 0000 0000"
	$"0000 0000 0000 FFF6 F6F6 F6F6 F6F6 F6FF"
	$"FFF6 F6F6 F6F6 F6F6 FF00 0000 0000 0000"
	$"0000 0000 0000 FFF6 F6F6 F6F6 F6F6 F6FF"
	$"FFF6 F6F6 F6F6 F6F6 FF00 0000 0000 0000"
	$"0000 0000 0000 FFF6 F6F6 F6F6 F6F6 F6FF"
	$"FFF6 F6F6 F6F6 F6F6 FF00 0000 0000 0000"
	$"0000 0000 0000 FFF6 F6F6 F6F6 F6F6 F6FF"
	$"FFF6 F6F6 FFFF FFFF FF00 0000 0000 0000"
	$"0000 0000 0000 FFFF FFFF FFF6 F6F6 F6FF"
	$"FFF6 F6F6 FFF7 F7F7 FF00 0000 0000 0000"
	$"0000 0000 0000 FFF7 F7F7 FFF6 F6F6 F6FF"
	$"FFF6 F6F6 FFF7 F7F7 FF00 0000 0000 0000"
	$"0000 0000 0000 FFF7 F7F7 FFFF FFF6 F6FF"
	$"FFF6 F6F6 FFF7 F7F7 FFFF FFFF FFFF FFFF"
	$"FFFF FFFF FFFF FFF7 F7F7 FF00 FFF6 F6FF"
	$"FFF6 F6F6 FFF7 F7F7 F7F7 F7F7 F7F7 F7F7"
	$"F7F7 F7F7 F7F7 F7F7 F7F7 FF00 FFF6 F6FF"
	$"FFF6 F6F6 FFF7 F7F7 F7F7 F7F7 F7F7 F7F7"
	$"F7F7 F7F7 F7F7 F7F7 F7F7 FF00 FFF6 F6FF"
	$"FFF6 F6F6 FFF7 F7F7 F7F7 F7F7 F7F7 F7F7"
	$"F7F7 F7F7 F7F7 F7F7 F7F7 FFFF FFF6 F6FF"
	$"FFF6 F6F6 FFF7 F7F7 F7F7 F7F7 F7F7 F7F7"
	$"F7F7 F7F7 F7F7 F7F7 F7F7 FFF6 F6F6 F6FF"
	$"FFF6 F6F6 FFF7 F7F7 F7F7 F7F7 F7F7 F7F7"
	$"F7F7 F7F7 F7F7 F7F7 F7F7 FFF6 F6F6 F6FF"
	$"FFF6 F6F6 FFFF FFFF FFFF FFFF FFFF FFFF"
	$"FFFF FFFF FFFF FFFF FFFF FFF6 F6F6 F6FF"
	$"FFF6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6"
	$"F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6FF"
	$"FFF6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6"
	$"F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6FF"
	$"FFF6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6"
	$"F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6FF"
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
};

